#include <qapplication.h>
#include <QMainWindow>

#include "stwidgetmainwindow.h"

#include "stsettings.h"

void stMessageOutput(QtMsgType type, const char *msg);

void stMessageOutput(QtMsgType type, const char *msg)
{
     switch (type) {
     case QtDebugMsg:
         fprintf(stderr, "Debug:\t%s\n", msg);
         break;
     case QtWarningMsg:
         fprintf(stderr, "Warning:\t%s\n", msg);
         break;
     case QtCriticalMsg:
         fprintf(stderr, "Critical:\t%s\n", msg);
         break;
     case QtFatalMsg:
         fprintf(stderr, "Fatal:\t%s\n", msg);
         abort();
     }
}


int main( int argc, char ** argv ) {	
	qInstallMsgHandler(stMessageOutput);
	
    QApplication a( argc, argv );

	QStringList argslist;
	for(int i=1; i<argc; i++) {
		argslist.append(argv[i]);
	}
	
	if( STSettings::is_another_running()) {
		for(int i=0; i < argslist.size() ; i++) {
			if( argslist.at(i).endsWith(".torrent")) {
				QFileInfo finfo( argslist.at(i) );
				STff::debug(D_INF, argslist.at(i));
				QFile::copy( argslist.at(i), STSettings::get_dir_dot_torrents_temp() + "/" + finfo.fileName());
				STSettings::set_value("ipc", "newfiles", true);
			}
		}
		STff::debug(D_INF, "another running, exiting.............................,.,.,.");
		return 1;
	}
	
	STWidgetMainWindow * mw = new STWidgetMainWindow();	
	
	
	STSession *session = new STSession(mw);
	session->slot_addTorrentFiles(argslist, false);
	
	mw->set_session(session);
	mw->show();
    
    mw->check_updates();
    
    a.connect( &a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()) );
    a.connect( &a, SIGNAL(aboutToQuit()), mw, SLOT(slot_about_to_quit()) );
    
    return a.exec();
}
