#include "stsettings.h"

using namespace st::core;

STSettings::STSettings()
{
}


STSettings::~STSettings()
{
}

/*!
    \fn STSettings::getValue(QString gn, QString vn)
 */
QVariant STSettings::value(QString gn, QString vn, QVariant default_value )
{
	QSettings settings(QSettings::IniFormat, QSettings::UserScope, "sfinks", "sharktorrent");
	
    settings.beginGroup(gn);
     	QVariant value = settings.value(vn, default_value);
     settings.endGroup();
     
     return value;
}


/*!
    \fn STSettings::setValue(QString gn, QString vn, QVariant value)
 */
bool STSettings::set_value(QString gn, QString vn, QVariant value)
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, "sfinks", "sharktorrent");
    
	settings.beginGroup(gn);
	settings.setValue(vn, value);
	settings.endGroup();
	
	return true;
}




/*!
    \fn STSettings::get_dir_dot_torrents()
 */
QString STSettings::get_dir_dot_torrents()
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, "sfinks", "sharktorrent");
	settings.beginGroup("limits");
	QString _tsd = QFileInfo(settings.fileName()).absoluteDir().canonicalPath() + "/torrents/";
	QString _ttd = QFileInfo(settings.fileName()).absoluteDir().canonicalPath() + "/temptorr/";
	settings.endGroup();
	
	return _tsd;
}


/*!
    \fn STSettings::get_dir_dot_torrents_temp()
 */
QString STSettings::get_dir_dot_torrents_temp()
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, "sfinks", "sharktorrent");
	settings.beginGroup("limits");
	QString _tsd = QFileInfo(settings.fileName()).absoluteDir().canonicalPath() + "/torrents/";
	QString _ttd = QFileInfo(settings.fileName()).absoluteDir().canonicalPath() + "/temptorr/";
	settings.endGroup();
	
	return _ttd;
}


/*!
    \fn STSettings::get_data_save_dir()
 */
QString STSettings::get_data_save_dir()
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, "sfinks", "sharktorrent");
	settings.beginGroup("limits");
	QString _ddir = settings.value("destdir", QDir::fromNativeSeparators(QDir::homePath()) + "/Desktop/torrents/").toString();
	settings.endGroup();
	
	return _ddir;
}


/*!
    \fn STSettings::update_ipc_timestamp()
	return true if there are new files to add, else return false
 */
bool STSettings::update_ipc_timestamp(uint _ts)
{
	bool b;
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, "sfinks", "sharktorrent");
	settings.beginGroup("ipc");
		uint ts;
		if(_ts == 0) {
			ts = QDateTime::currentDateTime().toTime_t();
		} else {
			ts = _ts;
		}
		settings.setValue("timestamp", ts);
		b = settings.value("newfiles", true).toBool();
		settings.setValue("newfiles", false);
	settings.endGroup();
	settings.sync();
	
	return b;
}


/*!
    \fn STSettings::is_another_running()
 */
bool STSettings::is_another_running()
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, "sfinks", "sharktorrent");
	settings.beginGroup("ipc");
		uint ts = settings.value("timestamp", ts).toUInt();
		if( (QDateTime::currentDateTime().toTime_t() - ts) < 6) return true;
	settings.endGroup();
	
	return false;
}


/*!
    \fn STSettings::get_data_save_finished_dir()
 */
QString STSettings::get_data_save_finished_dir()
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, "sfinks", "sharktorrent");
	settings.beginGroup("limits");
	QString _ddir = settings.value("movedir", QDir::fromNativeSeparators(QDir::homePath()) + "/Desktop/torrents/finished/").toString();
	settings.endGroup();
	
	return _ddir;
}

void STSettings::remove( const QString & group, const QString & key )
{
	QSettings settings(QSettings::IniFormat, QSettings::UserScope, "sfinks", "sharktorrent");
	settings.beginGroup(group);
	settings.remove(key);
	settings.endGroup();
}

/*!
    \fn st::core::STSettings::get_proxy()
 */
QNetworkProxy st::core::STSettings::get_proxy() 
{
    QNetworkProxy proxy;
    
    proxy.setHostName( STSettings::value("network", "proxy_hostname", "").toString());
    proxy.setPort( STSettings::value("network", "proxy_port", 0).toUInt());
    
    if( STSettings::value("network", "proxy_auth_bool", false).toBool() ) {
		proxy.setUser( STSettings::value("network", "proxy_user", "").toString());
		proxy.setPassword( STSettings::value("network", "proxy_password", "").toString());
	}
	
	return proxy;
}
