#ifndef STSETTINGS_H
#define STSETTINGS_H

#include <QSettings>
#include <QDir>
#include <QFileInfo>

#include <QDateTime>
#include <QNetworkProxy>

/**
	@author sfinks <sfinks2@gmail.com>
*/
namespace st {
namespace core {
class STSettings{
public:
    STSettings();

    ~STSettings();
    
    static bool set_value(QString gn, QString vn, QVariant value);
    static QVariant value(QString gn, QString vn, QVariant default_value = QVariant());
    static QString get_dir_dot_torrents_temp();
    static QString get_dir_dot_torrents();
    static QString get_data_save_dir();
    static bool is_another_running();
    
    static void remove( const QString & group, const QString & key );
    
    // return true if there are new files to add, else return false
    static bool update_ipc_timestamp(uint _ts=0);
    static QString get_data_save_finished_dir();
    static QNetworkProxy get_proxy() ;

};

}
}
#endif
