#ifndef STWIDGETDOWNLOADS_H
#define STWIDGETDOWNLOADS_H

#include <QWidget>
#include <QStringList>
#include <QStandardItemModel>
#include <QHeaderView>
#include <QMenu>
#include <QAction>

#include <QTreeWidget>
#include <QTreeWidgetItem>

#include "libtorrent/entry.hpp"
#include "libtorrent/bencode.hpp"
#include "libtorrent/session.hpp"
#include "libtorrent/identify_client.hpp"
#include "libtorrent/alert_types.hpp"
#include "libtorrent/ip_filter.hpp"
#include "libtorrent/hasher.hpp"

#include "ststandarditem.h"
#include "ui/uidownloads.h"
#include "stff.h"
#include "stsettings.h"

#include "stwidget.h"


#include <QThread>

using namespace Ui;
using namespace libtorrent;
using namespace st::core;
/**
	@author sfinks <sfinks2@gmail.com>
*/
namespace st {
namespace widgets {
class STWidgetDownloads : public STWidget
{
	Q_OBJECT
public:
    STWidgetDownloads(QWidget *parent = 0);

    ~STWidgetDownloads();
    QTreeView* get_treeWidget();
    QListWidget* get_listWidget();
    QStringList get_labels() const;
    
//    QStandardItemModel *m_model;
private:

	void sort()
	{
			Qt::SortOrder sortorder = m_hv->sortIndicatorOrder();
			int sortsection = m_hv->sortIndicatorSection ();
			m_model->sort( sortsection, sortorder);
	}

    void create_popup_menu();
    void create_treeview_header();
public:
	QAction *m_actionResume, *m_actionPause, *m_actionRemove;
protected:
	void updateModel(QList<QStringList> l);

private:
	UIDownloads *m_ui;
	QMenu *m_popup;
	QStringList prev_lwitems_str;
	QStandardItemModel *m_model;
	QHeaderView	*m_hv;
	QList<QString> m_list_of_map_keys_previous;
	QStringList	m_labels_previous;
		
signals:
    void signal_selected(QString hash);
private slots:
	void slot_popup(const QPoint &p);
	void slot_selectionChanged( const QItemSelection & selected, const QItemSelection & deselected );
public slots:
	void slot_update_model(map_string_stringlist l);
private slots:
    void slot_write_header_conf();
};
}
}
#endif
