#include "stwidgetstatus.h"

using namespace st::widgets;

STWidgetStatus::STWidgetStatus(QWidget *parent)
 : STWidget(parent)
{
	m_ui = new UIStatus(),
	m_ui->setupUi(this);
	
	m_model_1 = new QStandardItemModel( this );
	
	m_ui->treeView->setModel(m_model_1);

	create_treeview_header();
	
}


STWidgetStatus::~STWidgetStatus()
{
}




/*!
    \fn STWidgetStatus::slot_updateModel( map_string_stringlist l)
 */
void STWidgetStatus::slot_update_model( map_string_stringlist l)
{

	QStringList t2keys;
	t2keys << "url seeds" << "dht nodes" << "trackers" ;
		
	m_model_1->removeRows(0, m_model_1->rowCount());

	int m=0;
	
	QStringList sl;
	QString key;
	
	QList<QStandardItem *> qlsi;
	
	QMapIterator<QString, QStringList> i(l);
	while (i.hasNext()) {
		i.next();
		
		key = i.key();
		sl = i.value();
		
		qlsi.append( new QStandardItem( key));
		QString vstr;
		for(int k=0; k < sl.size(); k++) {
	
			if(k>0) vstr += "\n";
			vstr += sl.at(k);
		}
		qlsi.append( new QStandardItem( vstr ));
		
		
		m++;
		if(m == 2) {
			m_model_1->appendRow(qlsi);
			qlsi.clear();
			m=0;
		} else {
			qlsi.append( new QStandardItem( "" ));
		}
	}

}

void STWidgetStatus::create_treeview_header()
{
	m_hv = m_ui->treeView->header();

	QStringList h;
	h << "field" << "value" << ""
		<< "field" << "value";

	
	m_model_1->setHorizontalHeaderLabels(h);

	m_ui->treeView->setColumnWidth(0,250);
	m_ui->treeView->setColumnWidth(1,250);
	m_ui->treeView->setColumnWidth(2,10);
	m_ui->treeView->setColumnWidth(3,250);
	m_ui->treeView->setColumnWidth(4,250);
;



}
